
#include "stdafx.h"
#include "peter.h"
#include "IconBuf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ICONREZERVA 20				// rezerva pi zvtovn bufferu

////////////////////////////////////////////////////////////////////
// Pozor - linky BMP pro 256 barev jsou zarovnvny na 4 bajty !
//       - linky BMP pro 2 barvy (maska) jsou zarovnny na bajt !
////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CIconBuf::CIconBuf()
{
	m_Num = 0;								// poet ikon v bufferu
	m_Max = 0;								// velikost bufferu
	m_Width = 32;							// implicitn ka jedn ikony
	m_Height = 32;							// implicitn vka jedn ikony
	m_WidthByte = 32;						// dlka jedn linky v bajtech
	m_GenPal = FALSE;						// nejsou palety
	m_ItemSize = m_WidthByte * m_Height;	// velikost jedn ikony v bajtech
	m_Data = NULL;							// nejsou data bufferu
}

CIconBuf::~CIconBuf()
{
	free(m_Data);
}


/////////////////////////////////////////////////////////////////////////////
// nastaven nov velikosti bufferu (v potech ikon)

void CIconBuf::SetSize(int NewSize)
{
// oprava poadovan velikosti
	if (NewSize < 0) NewSize = 0;

// test, zda je zvten bufferu
	if (NewSize > m_Max)
	{

// pro ppad prvnho pouit inicializace
		m_WidthByte = (m_Width + 3) & ~0x3;	// dlka linky v bajtech
		m_ItemSize = m_WidthByte * m_Height; // velikost prvku v bajtech

// nastaven nov velikosti bufferu
		m_Max = NewSize + ICONREZERVA;
		Aloc(m_Data, m_Max*m_ItemSize);
	}

// nov poet ikon
	m_Num = NewSize;
}


/////////////////////////////////////////////////////////////////////////////
// zruen ikon z bufferu (implicitn 1 ikona)

void CIconBuf::Delete(int Index, int Count)
{
// korekce indexu
	if (Index >= m_Num)
		Index = m_Num - 1;		// maximln hodnota indexu
	if (Index < 0)
		Index = 0;				// minimln hodnota indexu

// korekce potu poloek ke zruen
	if (Index + Count > m_Num)
		Count = m_Num - Index;

// kontrola, zda je co ruit
	if (Count <= 0)
		return;

// psun zbylch poloek
	if (m_Num > (Index + Count))
		memmove(&m_Data[m_ItemSize*Index],
			&m_Data[m_ItemSize*(Index+Count)],
			m_ItemSize*(m_Num - (Index + Count)));

// zmna potu poloek
	m_Num -= Count;
}


/////////////////////////////////////////////////////////////////////////////
// pidn ikon z resource (num = poet, id = identifiktor)

void CIconBuf::LoadRes(int id)
{
// lokln promnn
	HRSRC res;						// resource identifiktor bitmapy
	HGLOBAL data;					// globln buffer dat bitmapy
	BITMAPINFO* bmp;				// ukazatel na data bitmapy
	int num;						// poet ikon v bitmap
	unsigned char* src;				// ukazatel zdrojov adresy
	unsigned char* dst;				// ukazatel clov adresy
	int srcinc;						// prustek zdrojov adresy = dlka linky
	int i,j;						// pracovn tae

// nalezen resource bitmapy
	res = ::FindResource(AfxGetResourceHandle(),
		MAKEINTRESOURCE(id), RT_BITMAP);
	ASSERT(res != NULL);

// naten bitmapy do pamti
	data = ::LoadResource(AfxGetResourceHandle(), res);
	ASSERT(data != NULL);

// ukazatel na data bitmapy
	bmp = (BITMAPINFO*) ::LockResource(data);

// pprava konverzn tabulky palet
	if (!m_GenPal)
	{
		GenKonvPal(bmp);
		m_GenPal = TRUE;
	}

// pprava zdrojov adresy
	src = (unsigned char*) &(bmp->bmiColors[256]);

// pprava potu ikon v bitmap
	num = bmp->bmiHeader.biWidth / m_Width;

// pprava prustku zdrojov adresy
	srcinc = (bmp->bmiHeader.biWidth + 3) & ~0x3;

// nastaven nov velikosti bufferu dat
	SetSize(m_Num + num);

// pprava ukldac adresy
	dst = &m_Data[m_ItemSize*(m_Num-num)];

// cyklus pes vechny importovan ikony
	for (i = num-1; i >= 0; i--)
	{

// cyklus pes vechny linky jedn ikony
		for (j = m_Height-1; j >= 0; j--)
		{

// kopie jedn linky ikony
//			memcpy(dst, src, m_Width);
			KonvCopy(dst, src, m_Width);

// zven ukldac a tec adresy
			dst += m_WidthByte;		// ukldac adresa
			src += srcinc;			// tec adresa
		}

// posun tec adresy na dal ikonu (ukldac adresa je OK)
		src -= m_Height*srcinc - m_Width;
	}
}

/////////////////////////////////////////////////////////////////////////////
// naten ikony ze souboru (vrac index ikony)

int CIconBuf::LoadFile(CString name)
{
// lokln promnn
	HANDLE hFile;						// handle souboru
	DWORD read;							// poet natench bajt
	BITMAPINFO* bmp = NULL;				// ukazatel na data bitmapy
	unsigned char* item;				// adresa obrzku

// buffer pro nateni zhlav
	Aloc(bmp, 1078);

// zven velikosti bufferu
	SetSize(m_Num+1);

// oteven souboru
	hFile = ::CreateFile(name, GENERIC_READ, 
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL, NULL);

// test, zda byl soubor oteven OK
	if (hFile != INVALID_HANDLE_VALUE)
	{

// nastaven ukazatele v souboru na data
		::SetFilePointer(hFile, sizeof(BITMAPFILEHEADER), NULL, FILE_BEGIN);

// naten zhlav souboru
		::ReadFile(hFile, bmp, 1078 - sizeof(BITMAPFILEHEADER), &read, NULL);

// pprava konverzn tabulky palet
//		GenKonvPal(bmp);
 
// adresa obrzku v bufferu
		item = Get(m_Num-1);

// naten souboru do bufferu
		::ReadFile(hFile, item, m_WidthByte*m_Height, &read, NULL);

// konverze palet
		KonvCopy(item, item, m_WidthByte*m_Height);

// uzaven souboru
		::CloseHandle(hFile);		// uzaven souboru
	}

// zruen bufferu
	Aloc(bmp, 0);

// navrcen indexu nov ikony
	return m_Num-1;
}


/////////////////////////////////////////////////////////////////////////////
// vygenerovn dat bitmapy
// barevn bitmapa m na konci rezervu pro zarovnn linky na 8 bajt

unsigned char* CIconBuf::GenerBitmap()
{
// lokln promnn
	unsigned char* data = NULL;		// adresa bufferu
	unsigned char* src;				// ukazatel zdrojov adresy
	unsigned char* dst;				// ukazatel clov adresy
	int dstinc;						// prustek clov adresy = dlka linky
	int i,j;						// pracovn tae

// prustek clov adresy = dlka linky
	dstinc = (m_Num*m_Width + 3) & ~0x3;

// vytvoen bufferu (s rezervou pro zarovnn linky na 8 bajt)
	Aloc(data, dstinc*m_Height + 7);

// ukazatele zdrojov a clov adresy
	dst = data;						// ukazatel clov adresy
	src = m_Data;					// ukazatel zdrojov adresy

// cyklus pes vechny exportovan ikony
	for (i = m_Num-1; i >= 0; i--)
	{

// cyklus pes vechny linky jedn ikony
		for (j = m_Height-1; j >= 0; j--)
		{

// kopie jedn linky ikony
			memcpy(dst, src, m_Width);

// zven ukldac a tec adresy
			src += m_WidthByte;		// tec adresa
			dst += dstinc;			// ukldac adresa
		}

// posun ukldac adresy na dal ikonu (tec adresa je OK)
		dst -= m_Height*dstinc - m_Width;
	}

// nvrat adresy bufferu
	return data;
}


/////////////////////////////////////////////////////////////////////////////
// vygenerovn masky ikon z dat barevn bitmapy
// barevn bitmapa mus mt na konci rezervu pro zarovnn linky na 8 bajt !

unsigned char* CIconBuf::GenerMask(unsigned char* bitmapa)
{
// lokln promnn
	int width;							// dlka linky (v bodech)
	int srcinc;							// prustek zdrojov adresy 
	int dstinc;							// prustek clov adresy
	unsigned char* src;					// ukazatel zdrojov adresy
	unsigned char* dst;					// ukazatel clov adresy
	unsigned char* data = NULL;			// adresa clovho bufferu
	unsigned char stradac;				// stada bit masky
	int i,j;							// pracovn tae

// dlka linky v bodech
	width = m_Num*m_Width;

// prustek zdrojov adresy
	srcinc = (width + 3) & ~0x3;

// prustek clov adresy
	dstinc = (width + 7) / 8;

// vytvoen bufferu pro masku
	Aloc(data, dstinc * m_Height);

// ukazatel clov adresy
	dst = data;							// ukazatel clov adresy

// cyklus pes vecny linky
	for (i = m_Height-1; i >= 0; i--)
	{

// ukazatel zdrojov adresy
		src = bitmapa + srcinc*i;

// cyklus pes vechny bajty clov linky
		for (j = dstinc - 1; j >= 0; j--)
		{

// vygenerovn bajtu pro 8 bod (me peshnout za konec linky)
			stradac = 0;				// pprava stadae
			if (src[0] == 0)			// je platn barva ?
				stradac = 0x80;			// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x40;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x20;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x10;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x08;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x04;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x02;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

			if (src[0] == 0)			// je platn barva ?
				stradac |= 0x01;		// pznak pozad
			src++;						// zven ukazatele dat bitmapy

// uloen clovho bajtu
			dst[0] = stradac;			// uloen stadae bit masky
			dst++;						// zven ukldac adresy masky
		}
	}

// adresa bufferu s daty
	return data;
}


/////////////////////////////////////////////////////////////////////////////
// vygenerovn seznamu ikon

CImageList* CIconBuf::GenerList()
{
// lokln promnn
	HIMAGELIST himg;			// seznam ikon Windows
	CImageList* list;			// seznam ikon - objekt
	unsigned char* data;		// data barevn bitmapy
	unsigned char* mono;		// data mono bitmapy (maska)
	CBitmap bmp, bmpMono;		// barevn a mono bitmapa
	HDC dc;						// handle kontextu displeje
	HPALETTE OldPal;			// schova pvodnch palet
	HBITMAP bitmap;				// handle barevn bitmapy

// vytvoen seznamu ikon
	list = new CImageList();
	himg = ImageList_Create(m_Width,m_Height, ILC_COLORDDB | ILC_MASK,m_Num,10);
	ASSERT(himg != NULL);		// vytvoeno OK ?
	list->Attach(himg);			// pipojen k objektu seznamu ikon

// vytvoen dat barevn a mono bitmapy
	data = GenerBitmap();		// vygenerovn barevn bitmapy
	mono = GenerMask(data);		// vygenerovn masky bitmapy

// vytvoen mono bitmapy (maska)
	bmpMono.CreateBitmap(m_Width*m_Num, m_Height, 1, 1, mono);

// oteven DC displeje
	dc = ::GetDC(0);
	ASSERT(dc != NULL);

// vbr a realizace vlastnch palet 
	OldPal = ::SelectPalette(dc, StdPalette, FALSE);
	::RealizePalette(dc);

// pprava zhlav BMP
	StdBitmapInfo->bmiHeader.biWidth = m_Width*m_Num;
	StdBitmapInfo->bmiHeader.biHeight = m_Height;

// vytvoen barevn bitmapy
	bitmap = ::CreateDIBitmap(dc,&(StdBitmapInfo->bmiHeader),
		CBM_INIT, data,StdBitmapInfo,DIB_RGB_COLORS);
	ASSERT(bitmap != NULL);

// pidn bitmapy k seznamu
	bmp.m_hObject = bitmap;
	list->Add(&bmp, &bmpMono);	
	
// uvolnn palet a DC displeje
	::SelectPalette(dc,OldPal,TRUE);
	::ReleaseDC(0,dc);

// zruen pracovnch buffer s daty
	Aloc(data, 0);
	Aloc(mono, 0);

// navrcen seznamu ikon
	return list;
}

