
////////////////////////////////////////////////////////////////////
// definice poloky mapy
//
// Poloky jsou v map ukldny zleva doprava od spodnho dku nahoru

#define MAXMAPWIDTH		1000	// maximln ka mapy
#define	MAXMAPHEIGHT	1000	// maximln vka mapy
#define	MAXMAPSIZE		100000	// maximln velikost mapy


typedef struct tagMAPITEM {
	short			icon;	// index ikony polka
	unsigned short	param;	// parametry polka - hodnota a pznaky
} MAPITEM;

typedef struct tagMAP {
	short	width;			// ka plochy
	short	height;			// vka ikony
	MAPITEM	item[1];		// poloky mapy
} MAP;

// parametry:
#define	MAP_VALUE		0x03FF	// maska hodnoty polka
#define MAP_FLAG0		0x0400	// pznak 0
#define MAP_FLAG1		0x0800	// pznak 1
#define MAP_FLAG2		0x1000	// pznak 2
#define MAP_FLAG3		0x2000	// pznak 3
#define MAP_FLAG4		0x4000	// pznak 4
#define MAP_FLAG5		0x8000	// pznak 5


////////////////////////////////////////////////////////////////////
// tda bufferu mapy

class CMapBuf : public CObject
{
public:
	CMapBuf();				// konstruktor
	virtual ~CMapBuf();		// destruktor

	BYTE*		m_Data;		// data map
	int*		m_Index;	// indexy map

	short		m_Num;		// poet poloek v bufferu
	short		m_IndexMax;	// velikost bufferu index map (poloek)

	int			m_DataNum;	// poet bajt v bufferu dat map
	int			m_DataMax;	// velikost bufferu dat map (bajt)

	CProgBuf*	m_ProgBuf;	// adresa tabulky buffer

// vyprzdnn bufferu
	inline void RemoveAll()
	{
		m_Num = 0;
		m_DataNum = 0;
	}

// zjitn adresy poloky
	inline MAP* Get(short Index)
	{
		if ((Index <= 0) || (Index >= m_Num))
			return (MAP*) m_Data;
		else
			return (MAP*) &(m_Data[m_Index[Index]]);
	}

// navrcen potu poloek v bufferu
	inline short GetNum()
		{ return m_Num; }

// pidn nov poloky do bufferu
	short Add(MAP* item);

// vytvoen nov mapy danch rozmr (vrac index, omez velikost)
	short New(short width, short height);

// vpoet velikosti mapy v bajtech
	inline int MapSize(MAP* map)
		{ return (map->width*map->height-1)*sizeof(MAPITEM) + sizeof(MAP); }

	inline int MapSize(short Index)
		{ return MapSize(Get(Index)); }

// zruen poloky z bufferu
	void Delete(short Index);

// nastaven nov velikosti mapy (omez velikost)
	void SetSize(short Index, short width, short height);
};

