// Peter.h : main header file for the PETER application
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// globln promnn

extern CString	Jmeno;				// jmno editovanho programu (bez cesty a bez ppony)

// parametry obrazovky
extern int ScreenWidth;				// ka obrazovky
extern int ScreenHeight;			// vka obrazovky

// konfiguran promnn
extern int Profile;					// slo profilu (z pkazovho dku)
extern CString ProfName;			// jmno profilu

extern int Scale;					// mtko pro relativn rozmry okna

extern int MainLeft;				// relativn pozice hlavnho okna vlevo
extern int MainTop;					// relativn pozice hlavnho okna nahoe
extern int MainWidth;				// relativn ka hlavnho okna
extern int MainHeight;				// relativn vka hlavnho okna

extern int LeftWidth;				// relativn ka levho pole (objekty)
extern int LeftHeight;				// relativn vka levho hornho okna (globln objekty)
extern int RightWidth;				// relativn ka pravho pole (tdy)
extern int RightHeight;				// relativn vka pravho hornho okna (struktury)

extern BOOL Maximized;				// pznak maximalizace okna

extern CString FindString;			// hledan text

// globln objekty
class CMainFrame;
extern	CMainFrame*	MainFrame;		// hlavn okno aplikace
class CPeterApp;
extern	CPeterApp theApp;			// hlavn objekt aplikace
class CProg;
extern CProg* Prog;					// hlavn okno programovn

//extern int		SelectWidth;		// ka pole pro vbr objektu a tidy
extern BITMAPINFO* StdBitmapInfo;	// standardn zhlav BMP
extern HPALETTE StdPalette;			// vlastn palety

extern unsigned char KonvPal[256];	// konverzn tabulka palet
extern void GenKonvPal(BITMAPINFO* bmp); // generovn konverzn tabulky

extern const int ColCol;			// poet barev standardnch palet
extern const int ColLev;			// poet rovn standardnch palet
extern const int StdColors;			// poet vlastnch palet (zanaj od 0)

// konverze barev
inline void KonvCopy(unsigned char* dst, unsigned char* src, int num)
{
	for (; num > 0; num--)
	{
		dst[0] = KonvPal[src[0]];
		dst++;
		src++;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CPeterApp:
// See Peter.cpp for the implementation of this class
//

class CPeterApp : public CWinApp
{
public:
	CPeterApp();
	~CPeterApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPeterApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CPeterApp)
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	void ReadIni();
	void ReadIniInt(int& result, LPCTSTR entry, int deflt);
	void WriteIni();
};


/////////////////////////////////////////////////////////////////////////////
// md editace ikony

enum EditMode
{ 
	EditModeElip,					// elipsa
	EditModeFill,					// vpl
	EditModeLine,					// ra
	EditModePaint,					// ttec
	EditModePen,					// pero
	EditModePipe,					// kaptko
	EditModeRect,					// obdlnk
	EditModeRound,					// kruh
	EditModeSelect,					// blok
	EditModeSpray,					// sprej
	EditModeXFlip,					// horizontln pevrcen
	EditModeYFlip,					// vertikln pevrcen
	EditModeRRot,					// otoen R
	EditModeLRot,					// otoen L
	EditModeXCol,					// zmna barev
};


/////////////////////////////////////////////////////////////////////////////
// realokace velkch buffer (adr = NULL vytvoen, size = 0 zruen)

void* _Aloc(void* adr, int size);

inline void Aloc(char*& adr, int size)
	{ adr = (char*)_Aloc(adr, size); }

inline void Aloc(unsigned char*& adr, int size)
	{ adr = (unsigned char*)_Aloc(adr, size); }

inline void Aloc(BITMAPINFO*& adr, int size)
	{ adr = (BITMAPINFO*)_Aloc(adr, size); }

inline void Aloc(double*& adr, int size)
	{ adr = (double*)_Aloc(adr, size); }

inline void Aloc(int*& adr, int size)				// velikost udna v potu poloek int !
	{ adr = (int*)_Aloc(adr, size*sizeof(int)); }
