
/////////////////////////////////////////////////////////////////////////////
//																		   //
//					obsluha taen rozdlova oken						   //
//																		   //
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// zobrazen kurzoru myi, nen-li taen ikon

BOOL CProg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	if (!m_Dragging)						// jen nen-li taen ikon
	{
// pprava kurzoru myi, je-li taen pedl
		if (m_Tracking)						// je taen pedl ?
		{
			if (m_HTracking)				// je taen horizontlnho pedlu ?
				m_CurAkt = m_CurVSize;		// vertikln kurzor myi
			else
				m_CurAkt = m_CurHSize;		// horizontln kurzor myi
		}
		else

// pprava kurzoru myi, nen-li dn taen
		{
			m_CurAkt = m_CurArrow;			// implicitn kurzor ipky

			POINT pt;
			::GetCursorPos(&pt);			// naten kurzoru myi

			if (WndHitTest(m_Split1, pt) ||	// je lev vertikln pedl ?
				WndHitTest(m_Split3, pt))	// je prav vertikln pedl ?
				m_CurAkt = m_CurHSize;		// horizontln kurzor myi
			else
				if (WndHitTest(m_Split2, pt) ||	// je lev horizontln pedl ?
					WndHitTest(m_Split4, pt))	// je prav horizontln pedl ?
					m_CurAkt = m_CurVSize;		// vertikln kurzor myi
		}

// zobrazen novho kurzoru myi
		::SetCursor(m_CurAkt);				// zobrazen kurzoru myi
		return TRUE;						// pznak, e se nem pokraovat
	}

// pokraovn implicitn obsluhou
	return CFormView::OnSetCursor(pWnd, nHitTest, message);
}


/////////////////////////////////////////////////////////////////////////////
// test kurzoru myi, zda je nad pedlem

BOOL CProg::WndHitTest(CWnd& wnd, POINT& pt)
{
	CRect rc;
	wnd.GetWindowRect(&rc);					// naten pozice a rozmr okna
	return rc.PtInRect(pt);					// test, zda je kurzor myi nad oknem
}


/////////////////////////////////////////////////////////////////////////////
// stisk levho tlatka myi - zahjen taen pedlu

void CProg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (!m_Tracking && !m_Dragging)			// jen nen-li dn taen
	{
		POINT pt;
		::GetCursorPos(&pt);				// naten pozice kurzoru myi

		if (BegTrack(m_Split1, pt, FALSE)	||	// lev vertikln pedl
			BegTrack(m_Split2, pt, TRUE)	||	// prav vertikln pedl
			BegTrack(m_Split3, pt, FALSE)	||	// lev horizontln pedl
			BegTrack(m_Split4, pt, TRUE))		// prav horizontln pedl
			return;
	}
	CFormView::OnLButtonDown(nFlags, point);
}


/////////////////////////////////////////////////////////////////////////////
// zahjen taen jednoho pedlu

BOOL CProg::BegTrack(CStatic& wnd, POINT& pt, BOOL HTrack)
{
// naten rozmr testovanho pedlu
	wnd.GetWindowRect(&m_TrackRect);

// test, zda je kurzor myi nad pedlem
	if (!m_TrackRect.PtInRect(pt))
		return FALSE;				// kurzor myi nen na pedlu

// zahjen taen - nastaven promnnch
	m_Tracking = TRUE;			// pznak probhajcho taen
	m_HTracking = HTrack;		// pznak horizontlnho pedlu
	m_TrackSplit = &wnd;		// okno taenho pedlu
	m_TrackDisp = FALSE;		// nen zobrazen pedl taen

// schova offsetu kurzoru myi od okraje pedlu
	if (HTrack)					// je horizontln pedl ?
		m_TrackSpot = pt.y - m_TrackRect.top; // vertikln offset kurzoru
	else
		m_TrackSpot = pt.x - m_TrackRect.left; // horizontln offset kurzoru

// inicializace taen
	ScreenToClient(&m_TrackRect); // pevod na klientsk souadnice
	SetCapture();				// zahjen zachytvn myi
	InvertTrack();				// zobrazen taenho obdlnku
	m_ReDispCount = 0;			// nen poadovno pekreslen
	m_TrackTimer = SetTimer(20,20,NULL); // vytvoen asovae
	return TRUE;				// pznak zahjen taen
}

/////////////////////////////////////////////////////////////////////////////
// ukonen taen pedlu (uvolnn levho tlatka myi)

void CProg::EndTrack()
{
// test, zda probh taen pedlu
	if (m_Tracking)
	{

// vypnut zobrazen pedlu
		if (m_TrackDisp) InvertTrack(); // vypnut obdlnku taen

// ukonen taen
		ReleaseCapture();			// ukonen zachytvn myi
		m_Tracking = FALSE;			// zruen pznaku taen
		KillTimer(m_TrackTimer);	// zruen asovae
		m_ReDispCount = 0;			// nen poadovno pekreslen

// pekreslen oken pi ukonen taen
		ReSize();					// pepoet oken

// aktualizace zobrazen lity pepna
		CRect rect;
		m_Edit.GetWindowRect(&rect); // naten pozice editnho okna
		ScreenToClient(&rect);		// pepoet na klientsk souadnice
		rect.bottom = rect.top;		// spodn okraj
		rect.top = 0;				// horn okraj
		RedrawWindow(&rect);		// pekreslen lity pepna

// aktualizace zobrazen okna
		Invalidate(FALSE);			// obsah okna neplatn
		UpdateWindow();				// zobrazen okna
	}
}


/////////////////////////////////////////////////////////////////////////////
// zapnut/vypnut obdlnku pedlu

void CProg::InvertTrack()
{
	CDC* pDC = GetDC();			// oteven DC
	HBRUSH hOldBrush = NULL;	// pvodn ttec
	CBrush* pBrush = CDC::GetHalftoneBrush(); // prokldan ttec
	if (pBrush != NULL)			// je ttec platn ?
		hOldBrush = (HBRUSH)SelectObject(pDC->m_hDC, pBrush->m_hObject);
	pDC->PatBlt(m_TrackRect.left, m_TrackRect.top, // zobrazen obdlnku
		m_TrackRect.Width(), m_TrackRect.Height(), PATINVERT);
	m_TrackDisp = !m_TrackDisp;	// zmna pznaku zobrazen obdlnku
	if (hOldBrush != NULL)
		SelectObject(pDC->m_hDC, hOldBrush); // nvrat pvodnho ttce
	ReleaseDC(pDC);				// uvolnn DC
}


/////////////////////////////////////////////////////////////////////////////
// posun my - taen pedlu

void CProg::MoveTrack(CPoint pt)
{
// jen je-li taen pedlu
	if (m_Tracking)				// je taen pedlu ?
	{

// naten rozmr hlavnho okna
		CRect rcw;				// klientsk rozmry okna
		GetClientRect(&rcw);	// naten rozmr okna
		CRect rc = m_TrackRect;	// pvodn pozice obdlnku

// test, zda je taen horizontlnho pedlu
		if (m_HTracking)
		{

// nov okraje horizontlnho pedlu
			rc.top = pt.y - m_TrackSpot;	// horn okraj pedlu
			if (rc.top < 0) rc.top = 0;		// omezen pi podteen
			if (rc.top > rcw.bottom - SplitSize) // omezen pi peteen
				rc.top = rcw.bottom - SplitSize;
			rc.bottom = rc.top + SplitSize;	// spodn okraj pedlu

// nov relativn pozice horizontlnho pedlu
			if (m_TrackSplit == &m_Split2)	// je lev pedl ?
				LeftHeight = (rc.top*Scale + rcw.bottom/2)/rcw.bottom;
			else
				RightHeight = (rc.top*Scale + rcw.bottom/2)/rcw.bottom;
		}
		else
		{

// nov okraje vertiklnho pedlu
			rc.left = pt.x - m_TrackSpot;	// lev okraj pedlu
			if (rc.left < 0) rc.left = 0;	// omezen pi podteen
			if (rc.left > rcw.right - SplitSize) // omezen pi peteen
				rc.left = rcw.right - SplitSize;

// nov relativn pozice vertiklnho pedlu
			if (m_TrackSplit == &m_Split1)	// je lev pedl ?
			{
				LeftWidth = (rc.left*Scale + rcw.right/2)/rcw.right;
				if (rc.left > rcw.right - 2*SplitSize) // omezen levho pedlu
					rc.left = rcw.right - 2*SplitSize;
			}
			else
				RightWidth = Scale - (rc.left*Scale + rcw.right/2)/rcw.right;

			rc.right = rc.left + SplitSize;	// prav okraj pedlu
		}

// aktualizace zobrazen pedlu
		if (rc != m_TrackRect)				// zmnila se pozice pedlu ?
		{
			InvertTrack();					// vypnut pedlu
			m_TrackRect = rc;				// nov pozice
			m_ReDispCount = 2;				// poadavek pekreslen okna
			InvertTrack();					// zapnut pedlu
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// obsluha asovae pro pekreslen okna pi taen pedlu

void CProg::OnTimer(UINT nIDEvent) 
{
// ta pro obsluhu zobrazen
	if (m_ReDispCount)						// je poadovno zobrazen ?
	{
		m_ReDispCount--;					// snen tae ekn na zobrazen

// test, zda je ji dosaeno asu k zobrazen pedlu
		if (!m_ReDispCount)					// uplynula doba k zobrazen ?
		{			

// vypnut ppadn zobrazenho pedlu
			BOOL OldTrackDisp = m_TrackDisp;// schova pznaku zobrazen pedlu
			if (m_TrackDisp) InvertTrack();	// vypnut pedlu

// pepoet novho rozloen okna
			ValidateRect(NULL);				// zatm okno nezobrazovat
			ReSize();						// pepoet rozloen okna

// aktualizace zobrazen lity s tlatky
			CRect rect;
			m_Edit.GetWindowRect(&rect);	// naten pozice editanho okna
			ScreenToClient(&rect);			// pepoet na klientsk souadnice
			rect.bottom = rect.top;			// spodn okraj lity s tlatky
			rect.top = 0;					// horn okraj lity s tlatky
			RedrawWindow(&rect);			// pekreslen lity s tlatky

// aktualizace zobrazen okna (bez pekreslen pozad)
			Invalidate(FALSE);				// zneplatnn celho okna
			UpdateWindow();					// aktualizace zobrazen okna

// ppadn zapnut zobrazen pedlu
			if (OldTrackDisp) InvertTrack(); // zobrazen pedlu
		}
	}
	CFormView::OnTimer(nIDEvent);			// pokraovn pvodn obsluhou asovae
}

