
#include "stdafx.h"
#include "peter.h"
#include "RealBuf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define REALREZERVA 100			// rezerva pi zvtovn bufferu

////////////////////////////////////////////////////////////////////
// konstruktor a destruktor

CRealBuf::CRealBuf()
{
	m_pData = NULL;
	m_nSize = 0;				// nen dn prvek
	m_nMaxSize = 0;				// maximln velikost
}

CRealBuf::~CRealBuf()
{
	Aloc(m_pData, 0);			// zruen bufferu
}


////////////////////////////////////////////////////////////////////
// nastaven nov velikosti bufferu

void CRealBuf::SetSize(int nNewSize)
{
// oprava poadovan velikosti
	if (nNewSize < 0)			// je velikost zporn ?
		nNewSize = 0;			// oprava daje

// test, zda je zvten bufferu
	if (nNewSize > m_nMaxSize)
	{

// nastaven nov velikosti bufferu
		m_nMaxSize = nNewSize + REALREZERVA;	// nov velikost bufferu

// vytvoen novho bufferu
		Aloc(m_pData, m_nMaxSize * sizeof(double));
	}

// nov poet poloek
	m_nSize = nNewSize;
}


////////////////////////////////////////////////////////////////////
// zruen poloky s danm indexem (implicitn 1 poloka)

void CRealBuf::Delete(int nIndex, int nCount)
{
// korekce indexu
	if (nIndex >= m_nSize)
		nIndex = m_nSize-1;		// maximln hodnota indexu
	if (nIndex < 0)
		nIndex = 0;				// minimln hodnota indexu

// korekce potu poloek ke zruen
	if (nIndex + nCount > m_nSize)
		nCount = m_nSize - nIndex;

// kontrola, zda je co ruit
	if (nCount <= 0)
		return;

// psun zbylch poloek
	if (m_nSize > (nIndex + nCount))
		memmove(&m_pData[nIndex], &m_pData[nIndex + nCount],
			(m_nSize - (nIndex + nCount)) * sizeof(double));

// zmna potu poloek
	m_nSize -= nCount;
}

